import { TokenConfig as TokenConfigV1, TokensConfig as TokensConfigV1 } from './types';
import { Chain } from '@wormhole-foundation/sdk';
import * as v1 from 'sdklegacy';
import * as v2 from '@wormhole-foundation/sdk';
export declare class SDKConverter {
    wh: v1.WormholeContext;
    constructor(wh: v1.WormholeContext);
    toTokenIdV1(token: v2.TokenId): v1.TokenId | undefined;
    toTokenIdV2(token: v1.TokenId | TokenConfigV1, chain?: Chain): v2.TokenId;
    tokenIdV2<C extends Chain>(chain: C, address: string): v2.TokenId<C>;
    isTokenConfigV1(v: v1.TokenId | TokenConfigV1): v is TokenConfigV1;
    findTokenConfigV1(tokenId: v2.TokenId, tokenConfigs: TokenConfigV1[]): TokenConfigV1 | undefined;
    getTokenIdV2ForKey<C extends Chain>(key: string, chain: C, tokenConfigs: TokensConfigV1): Promise<v2.TokenId<C> | undefined>;
    getNativeTokenAddressV2(token: TokenConfigV1): string | undefined;
}
//# sourceMappingURL=converter.d.ts.map